

	var _sock = async_load[? "id"];
	
	if (_sock == server) {
		var _type = async_load[? "type"];
		var _othersock = async_load[? "socket"]; // newly created socket
		
		// connect
		if (_type == network_type_connect) {
			show_debug_message(string("S: new client connected on socket {0}", _othersock));
			// create 
			ds_list_add(sockets, _othersock);
			// create instance
			var _instance = instance_create_layer(50, 50, layer, obj_player);
			_instance.desc = string("Socket: {0}", _othersock);
			ds_map_add(clients, _othersock, _instance);
		} else if (_type == network_type_disconnect) {
			
			scr_disconnect_socket(_othersock);
			
		} else if (_type == network_type_data) {
			// Yes he was!
			show_debug_message("S: Network type data");
		} else {
			show_debug_message(string("S: Networking, unknown type {0}.", _type));
		}
	} else {
		// another socket
		show_debug_message("S: got some data");
		show_debug_message(server);
		show_debug_message(_sock);
		
		if (ds_list_find_index(sockets, _sock) < 0) {
			show_debug_message(string("S: seems that this data is for client, as it's not on my socket list {0}", _sock));
			exit;
		}
		
		var _buff = async_load[? "buffer"];
		
		show_debug_message(string("S: buffer size is {0}", buffer_get_size(_buff)));
		
		buffer_seek(_buff, buffer_seek_start, 0);
		var _command = buffer_read(_buff, buffer_u8);
		var _p = clients[? _sock];
		
		if (!instance_exists(_p)) {
			// client disconnected ?
			scr_disconnect_socket(_sock);
			return;
		}
		
		_p.timeout = 0;
		
		switch(_command) {
			case PACKET_POSITION:
				_p.destx = buffer_read(_buff, buffer_u16);		
				_p.desty = buffer_read(_buff, buffer_u16);
				show_debug_message(string("S: position changed: {0}, {1}", _p.destx, _p.desty));
			break;
			
			default:
				show_debug_message("S: Unknown packet!");
		}
	}